diff -bruN freeswan-1.9.orig/pluto/xmap_file.c freeswan-1.9/pluto/xmap_file.c
--- freeswan-1.9.orig/pluto/xmap_file.c	Wed Dec 31 19:00:00 1969
+++ freeswan-1.9/pluto/xmap_file.c	Wed May 16 10:57:20 2001
@@ -0,0 +1,359 @@
+#ifdef OPENSSL
+#include <stdio.h>
+#include <stdlib.h>
+#include <unistd.h>
+#include <string.h>
+#include <sys/socket.h>
+#include <netinet/in.h>
+#include <arpa/inet.h>
+
+#include <regex.h>
+
+#include <openssl/bio.h>
+#include <openssl/pem.h>
+#include <openssl/x509v3.h>
+
+#include "xmap.h"
+#include "xmap_file.h"
+
+#include <freeswan.h> /* needed by constants.h */
+#include "constants.h"
+#include "defs.h"
+#include "log.h"
+
+static void XMAP_FILE_dump(void *this);
+static void XMAP_FILE_free(void *this);
+static void *XMAP_FILE_new(const char *file);
+static int isCA( X509 *x );
+static STACK_OF(X509_OBJECT) *
+XMAP_FILE_lookup( void *this, const int type, const char *index, void *p );
+static STACK_OF(X509_OBJECT) *
+XMAP_FILE_lookup_cert_by_subject( XMAP_FILE *xm, X509_NAME *name );
+static STACK_OF(X509_OBJECT) *
+XMAP_FILE_lookup_cert_by_issuer( XMAP_FILE *xm, X509_NAME *name );
+static STACK_OF(X509_OBJECT) *
+XMAP_FILE_lookup_crl_by_issuer( XMAP_FILE *xm, X509_NAME *name );
+static STACK_OF(X509_OBJECT) *
+XMAP_FILE_lookup_cert_by_uid( XMAP_FILE *xm, const char *uid );
+static STACK_OF(X509_OBJECT) *
+XMAP_FILE_lookup_cert_by_dns( XMAP_FILE *xm, const char *dns );
+static STACK_OF(X509_OBJECT) *
+XMAP_FILE_lookup_cert_by_ip( XMAP_FILE *xm, const struct in_addr ip );
+static STACK_OF(X509_OBJECT) *
+XMAP_FILE_lookup_ca_certs( XMAP_FILE *xm );
+
+static XMAP_METHOD xmap_file_methods = {
+  "file",
+  XMAP_FILE_lookup,
+  XMAP_FILE_dump,
+  XMAP_FILE_free,
+  XMAP_FILE_new
+};
+
+/* Pattern is (ignoring lower/upper case --
+ * <whitespace>uid:<whitespace><alphanumeric user id><whitespace>
+ */
+#define UID_REGEX \
+"^[[:space:]]*[Uu][Ii][Dd]:[[:space:]]*([[:alnum:]]+)[[:space:]]$"
+
+static int
+isCA( X509 *x )
+{
+  X509_EXTENSION *ext;
+  BASIC_CONSTRAINTS *p = NULL;
+  int loc;
+  
+  loc = X509_get_ext_by_NID(x, NID_basic_constraints, -1);
+  if (loc >= 0) {
+    ext = X509_get_ext(x, loc);
+    if (ext) {
+      p = X509V3_EXT_d2i(ext);
+      if (! p->ca) {
+	BASIC_CONSTRAINTS_free(p);
+	return 0;
+      } else {
+	BASIC_CONSTRAINTS_free(p);
+	return 1; /* This is a CA certificate */
+      }
+    } else
+      return 0;
+  } else
+    return 0;
+}
+
+XMAP_METHOD *
+XMAP_METHOD_file( void )
+{
+  return (&xmap_file_methods);
+}
+
+static void *
+XMAP_FILE_new(const char *file)
+{
+  XMAP_FILE *ret;
+  int re_code;
+  char errbuf[257];
+
+  if ((ret = alloc_thing(XMAP_FILE, "xmap_file")) == NULL) goto end;
+  if ((ret->file = clone_bytes(file, strlen(file)+1, "file name")) == NULL)
+    goto end;
+  if ((ret->bio = BIO_new_file(ret->file, "r")) == NULL) goto end;
+
+  if ((re_code = regcomp(&ret->uidreg, UID_REGEX, REG_EXTENDED)) != 0) {
+    regerror(re_code, &ret->uidreg, errbuf, sizeof(errbuf-1));
+    log("Regex Error: %s", errbuf);
+    goto end;
+  }
+
+  ret->meth = &xmap_file_methods;
+  return (void *)ret;
+ end:
+  if (ret->bio) BIO_free(ret->bio);
+  if (ret->file) pfree(ret->file);
+  if (ret) pfree(ret);
+  return NULL;
+}
+
+static STACK_OF(X509_OBJECT) *
+XMAP_FILE_lookup( void *this, const int type, const char *index, void *p )
+{
+  XMAP_FILE *xm = (XMAP_FILE *)this;
+
+  switch(type) {
+  case X509_LU_X509:
+    if (strcasecmp(index, "issuer") == 0)
+	{
+		return XMAP_FILE_lookup_cert_by_issuer( xm, (X509_NAME *)p);
+	}
+    if (strcasecmp(index, "subject") == 0)
+	{
+		return XMAP_FILE_lookup_cert_by_subject( xm, (X509_NAME *)p);
+	}
+    else if (strcasecmp(index, "uid") == 0)
+	{
+		return XMAP_FILE_lookup_cert_by_uid( xm, (char  *)p);
+	}
+    else if (strcasecmp(index, "dns") == 0)
+	{
+		return XMAP_FILE_lookup_cert_by_dns( xm, (char  *)p);
+	}
+    else if (strcasecmp(index, "ip") == 0)
+	{
+		return XMAP_FILE_lookup_cert_by_ip( xm, *((struct in_addr *)p));
+	}
+    else if (strcasecmp(index, "ca") == 0)
+	{
+		return XMAP_FILE_lookup_ca_certs( xm );
+	}
+    else
+	{
+		return NULL;
+	}
+    break;
+  case X509_LU_CRL:
+    if (strcasecmp(index, "issuer") == 0)
+      return XMAP_FILE_lookup_crl_by_issuer( xm, (X509_NAME *)p);
+    else
+      return NULL;
+    break;
+  default:
+    return NULL;
+  }
+}
+
+static STACK_OF(X509_OBJECT) *
+XMAP_FILE_lookup_cert_by_subject( XMAP_FILE *xm, X509_NAME *name )
+{
+  X509 *x;
+  STACK_OF(X509_OBJECT) *sk = sk_X509_OBJECT_new_null();
+
+  if (sk == NULL) return sk;
+  BIO_ctrl(xm->bio, BIO_CTRL_RESET, 0, NULL);
+  while ((x = PEM_read_bio_X509(xm->bio, NULL, NULL, NULL)) != NULL) {
+    if (X509_NAME_cmp(X509_get_subject_name(x), name) == 0) {
+      X509_OBJECT *xo = X509_OBJECT_new(X509_LU_X509, x);
+      if (xo) {
+	sk_X509_OBJECT_push(sk, xo);
+      } else
+	X509_free(x);
+    } else
+      X509_free(x);
+  }
+  return sk;
+}
+
+static STACK_OF(X509_OBJECT) *
+XMAP_FILE_lookup_cert_by_issuer( XMAP_FILE *xm, X509_NAME *name )
+{
+  X509 *x;
+  STACK_OF(X509_OBJECT) *sk = sk_X509_OBJECT_new_null();
+
+  if (sk == NULL) return sk;
+  BIO_ctrl(xm->bio, BIO_CTRL_RESET, 0, NULL);
+  while ((x = PEM_read_bio_X509(xm->bio, NULL, NULL, NULL)) != NULL) {
+    if (X509_NAME_cmp(X509_get_issuer_name(x), name) == 0) {
+      X509_OBJECT *xo = X509_OBJECT_new(X509_LU_X509, x);
+      if (xo) {
+	sk_X509_OBJECT_push(sk, xo);
+      } else
+	X509_free(x);
+    } else
+      X509_free(x);
+  }
+  return sk;
+}
+
+static STACK_OF(X509_OBJECT) *
+XMAP_FILE_lookup_ca_certs( XMAP_FILE *xm  )
+{
+  X509 *x;
+  STACK_OF(X509_OBJECT) *sk = sk_X509_OBJECT_new_null();
+
+  if (sk == NULL) return sk;
+  BIO_ctrl(xm->bio, BIO_CTRL_RESET, 0, NULL);
+  while ((x = PEM_read_bio_X509(xm->bio, NULL, NULL, NULL)) != NULL) {
+    if (isCA(x)) {
+      X509_OBJECT *xo = X509_OBJECT_new(X509_LU_X509, x);
+      if (xo) {
+	sk_X509_OBJECT_push(sk, xo);
+      } else
+	X509_free(x);
+    } else
+      X509_free(x);
+  }
+  return sk;
+}
+
+static STACK_OF(X509_OBJECT) *
+XMAP_FILE_lookup_crl_by_issuer( XMAP_FILE *xm, X509_NAME *name )
+{
+  X509_CRL *c;
+  STACK_OF(X509_OBJECT) *sk = sk_X509_OBJECT_new_null();
+
+  if (sk == NULL) return sk;
+  BIO_ctrl(xm->bio, BIO_CTRL_RESET, 0, NULL);
+  while ((c = PEM_read_bio_X509_CRL(xm->bio, NULL, NULL, NULL)) != NULL) {
+    if (X509_NAME_cmp(X509_CRL_get_issuer(c), name) == 0) {
+      X509_OBJECT *xo = X509_OBJECT_new(X509_LU_CRL, c);
+      if (xo) {
+	sk_X509_OBJECT_push(sk, xo);
+      } else
+	X509_CRL_free(c);
+    } else
+      X509_CRL_free(c);
+  }
+  return sk;
+}
+
+static STACK_OF(X509_OBJECT) *
+XMAP_FILE_lookup_cert_by_uid( XMAP_FILE *xm, const char *uid )
+{
+  char line[BUFSIZ+1], user[BUFSIZ+1];
+  regmatch_t pmatch[2];
+  STACK_OF(X509_OBJECT) *sk = sk_X509_OBJECT_new_null();
+  X509 *x;
+
+  if (sk == NULL) return sk;
+  BIO_ctrl(xm->bio, BIO_CTRL_RESET, 0, NULL);
+  while (BIO_gets(xm->bio, line, sizeof(line)-1)) {
+    if (!regexec(&xm->uidreg, line, 2, pmatch, 0))
+      if ((pmatch[1].rm_so != -1) && (pmatch[1].rm_eo != -1)) {
+	memset(user, 0, sizeof(user));
+	strncpy(user, &line[pmatch[1].rm_so],
+		pmatch[1].rm_eo - pmatch[1].rm_so);
+	if (strcmp(uid, user) == 0) {
+	  /* Found a match for the user id */
+	  if ((x = PEM_read_bio_X509(xm->bio, NULL, NULL, NULL)) != NULL) {
+	    X509_OBJECT *xo = X509_OBJECT_new( X509_LU_X509, x);
+	    if (xo) {
+	      sk_X509_OBJECT_push(sk, xo);
+	    } else 
+	      X509_free(x);
+	  }
+	}
+      }
+  }
+
+  return sk;
+}
+
+static STACK_OF(X509_OBJECT) *
+XMAP_FILE_lookup_cert_by_dns( XMAP_FILE *xm, const char *dns )
+{
+  STACK_OF(X509_OBJECT) *sk = sk_X509_OBJECT_new_null();
+  X509 *x;
+  int zap;
+  X509_OBJECT *xo;
+
+  if (sk == NULL) return sk;
+  BIO_ctrl(xm->bio, BIO_CTRL_RESET, 0, NULL);
+  while ((x = PEM_read_bio_X509(xm->bio, NULL, NULL, NULL)) != NULL) {
+    zap = X509_subjAltName_check_dns(x, dns) ? 0 : 1;
+    
+    if (zap)
+      X509_free(x);
+    else {
+      xo = X509_OBJECT_new( X509_LU_X509, x);
+      if (xo)
+	sk_X509_OBJECT_push(sk, xo);
+      else 
+	X509_free(x);
+    }
+  }
+
+  return sk;
+}
+
+static STACK_OF(X509_OBJECT) *
+XMAP_FILE_lookup_cert_by_ip( XMAP_FILE *xm, struct in_addr ip )
+{
+  STACK_OF(X509_OBJECT) *sk = sk_X509_OBJECT_new_null();
+  X509 *x;
+  int zap;
+  X509_OBJECT *xo;
+
+  if (sk == NULL) {
+    DBG(DBG_PARSING,
+    DBG_log("sk is NULL, returning NULL.");
+    );
+	return sk;
+  }
+  BIO_ctrl(xm->bio, BIO_CTRL_RESET, 0, NULL);
+  while ((x = PEM_read_bio_X509(xm->bio, NULL, NULL, NULL)) != NULL) {
+    zap = X509_subjAltName_check_ip(x, ip) ? 0 : 1;
+
+    if (zap)
+      X509_free(x);
+    else {
+      xo = X509_OBJECT_new( X509_LU_X509, x);
+      if (xo)
+		sk_X509_OBJECT_push(sk, xo);
+      else 
+		X509_free(x);
+    }
+  }
+
+  return sk;
+}
+
+static void
+XMAP_FILE_dump(void *this)
+{
+  XMAP_FILE *xm = (XMAP_FILE *)this;
+  DBG(DBG_CONTROL | DBG_PARSING,
+  DBG_log("XMAP_FILE: %s\n", xm->file);
+  );
+}
+
+static void
+XMAP_FILE_free(void *this)
+{
+  XMAP_FILE *xm = (XMAP_FILE *)this;
+
+  if (!xm) return;
+  regfree(&xm->uidreg);
+  if (xm->bio) BIO_free(xm->bio);
+  if (xm->file) pfree(xm->file);
+  pfree(xm);
+}
+#endif /* OPENSSL */
diff -bruN freeswan-1.9.orig/pluto/xmap_file.h freeswan-1.9/pluto/xmap_file.h
--- freeswan-1.9.orig/pluto/xmap_file.h	Wed Dec 31 19:00:00 1969
+++ freeswan-1.9/pluto/xmap_file.h	Wed May 16 10:57:20 2001
@@ -0,0 +1,28 @@
+#ifndef XMAP_FILE_H
+#define XMAP_FILE_H
+
+#include <regex.h>
+
+#include <openssl/safestack.h>
+#include <openssl/bio.h>
+#include <openssl/x509.h>
+#include <openssl/x509_vfy.h>
+
+#include "x_sobj.h"
+#include "xmap.h"
+
+typedef struct xmap_file_st {
+  char *file;
+  BIO *bio;
+  regex_t uidreg;
+  regex_t ipreg;
+  XMAP_METHOD *meth;
+} XMAP_FILE;
+
+XMAP_METHOD *XMAP_METHOD_file( void );
+#endif /* XMAP_FILE_H */
+
+
+
+
+
